"use strict";

var _interopRequireDefault = require("C:\\dev-github\\davefud\\spunky-ui-react\\node_modules\\@babel\\runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _objectWithoutProperties2 = _interopRequireDefault(require("C:\\dev-github\\davefud\\spunky-ui-react\\node_modules\\@babel\\runtime/helpers/esm/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("C:\\dev-github\\davefud\\spunky-ui-react\\node_modules\\@babel\\runtime/helpers/esm/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("C:\\dev-github\\davefud\\spunky-ui-react\\node_modules\\@babel\\runtime/helpers/esm/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("C:\\dev-github\\davefud\\spunky-ui-react\\node_modules\\@babel\\runtime/helpers/esm/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("C:\\dev-github\\davefud\\spunky-ui-react\\node_modules\\@babel\\runtime/helpers/esm/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("C:\\dev-github\\davefud\\spunky-ui-react\\node_modules\\@babel\\runtime/helpers/esm/inherits"));

var _assertThisInitialized2 = _interopRequireDefault(require("C:\\dev-github\\davefud\\spunky-ui-react\\node_modules\\@babel\\runtime/helpers/esm/assertThisInitialized"));

var _react = _interopRequireDefault(require("react"));

var _ProgressBar = _interopRequireDefault(require("../ProgressBar"));

var _EyeIcon = _interopRequireDefault(require("../EyeIcon"));

var _Label = _interopRequireDefault(require("../Label"));

var _server = require("react-dom/server");

/** Password input with integrated label, quality tips, and show password toggle. */
var Input =
/*#__PURE__*/
function (_React$Component) {
  (0, _inherits2.default)(Input, _React$Component);

  function Input(props) {
    var _this;

    (0, _classCallCheck2.default)(this, Input);
    _this = (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(Input).call(this, props));

    _this.toggleShowPassword = function (ev) {
      _this.setState(function (prevState) {
        return {
          showPassword: !prevState.showPassword
        };
      });

      if (ev) ev.preventDefault();
    };

    _this.state = {
      showPassword: false
    };
    _this.toggleShowPassword = _this.toggleShowPassword.bind((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)));
    return _this;
  } // ES7 class properties


  (0, _createClass2.default)(Input, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          htmlId = _this$props.htmlId,
          value = _this$props.value,
          label = _this$props.label,
          error = _this$props.error,
          onChange = _this$props.onChange,
          placeholder = _this$props.placeholder,
          maxLength = _this$props.maxLength,
          showVisibilityToggle = _this$props.showVisibilityToggle,
          quality = _this$props.quality,
          props = (0, _objectWithoutProperties2.default)(_this$props, ["htmlId", "value", "label", "error", "onChange", "placeholder", "maxLength", "showVisibilityToggle", "quality"]);
      var showPassword = this.state.showPassword;
      var svgString = encodeURIComponent((0, _server.renderToStaticMarkup)(_react.default.createElement(_EyeIcon.default, {
        size: 16
      })));
      var dataUri = "url(\"data:image/svg+xml,".concat(svgString, "\") center / contain no-repeat");
      var normalStyle = {
        padding: '10px 35px 10px 10px',
        width: '235px'
      };
      var errorStyle = {
        padding: '10px 35px 10px 10px',
        width: '235px',
        border: 'solid 1px red'
      };
      var styles = error ? errorStyle : normalStyle;
      return _react.default.createElement("div", null, _react.default.createElement(_Label.default, {
        htmlFor: htmlId,
        label: label,
        required: true
      }), _react.default.createElement("div", {
        style: {
          position: 'relative',
          maxWidth: '235px',
          cursor: 'pointer'
        }
      }, _react.default.createElement("span", {
        style: {
          content: "",
          position: 'absolute',
          left: '255px',
          top: 0,
          bottom: 0,
          width: '16px',
          background: dataUri
        },
        onClick: this.toggleShowPassword
      }), _react.default.createElement("label", {
        style: {
          maxWidth: '250px'
        }
      }, _react.default.createElement("input", Object.assign({
        id: htmlId,
        type: showPassword ? 'text' : 'password',
        placeholder: placeholder,
        value: value,
        onChange: onChange,
        style: styles
      }, props)), error && _react.default.createElement("div", {
        className: "error",
        style: {
          color: 'red',
          fontSize: '.75em',
          fontWeight: 'bold'
        }
      }, error))), value.length > 0 && quality && _react.default.createElement(_ProgressBar.default, {
        percent: quality,
        width: 130
      }));
    }
  }]);
  return Input;
}(_react.default.Component);

Input.defaultProps = {
  maxLength: 50,
  showVisibilityToggle: false,
  label: 'Password'
};
var _default = Input;
exports.default = _default;