"use strict";

var _interopRequireWildcard = require("C:\\dev-github\\davefud\\spunky-ui-react\\node_modules\\@babel\\runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("C:\\dev-github\\davefud\\spunky-ui-react\\node_modules\\@babel\\runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("C:\\dev-github\\davefud\\spunky-ui-react\\node_modules\\@babel\\runtime/helpers/esm/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("C:\\dev-github\\davefud\\spunky-ui-react\\node_modules\\@babel\\runtime/helpers/esm/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("C:\\dev-github\\davefud\\spunky-ui-react\\node_modules\\@babel\\runtime/helpers/esm/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("C:\\dev-github\\davefud\\spunky-ui-react\\node_modules\\@babel\\runtime/helpers/esm/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("C:\\dev-github\\davefud\\spunky-ui-react\\node_modules\\@babel\\runtime/helpers/esm/inherits"));

var _react = _interopRequireDefault(require("react"));

var PercentUtils = _interopRequireWildcard(require("../utils/percentUtils"));

/** Progress bar with color coded status of progress */
var ProgressBar =
/*#__PURE__*/
function (_React$Component) {
  (0, _inherits2.default)(ProgressBar, _React$Component);

  function ProgressBar() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, ProgressBar);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(ProgressBar)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _this.getColor = function (percent) {
      if (_this.props.percent === 100) return 'green';
      return _this.props.percent > 50 ? 'lightgreen' : 'red';
    };

    return _this;
  }

  (0, _createClass2.default)(ProgressBar, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          percent = _this$props.percent,
          width = _this$props.width,
          height = _this$props.height;
      var percentWidth = PercentUtils.getWidthAsPercentOfTotalWidth(percent, width);
      return _react.default.createElement("div", null, "\xA0\xA0\xA0\xA0\xA0\xA0\xA0\xA0", _react.default.createElement("div", {
        style: {
          width: percentWidth,
          height: height,
          backgroundColor: this.getColor(percent)
        }
      }), "\xA0\xA0\xA0\xA0\xA0\xA0");
    }
  }]);
  return ProgressBar;
}(_react.default.Component);

ProgressBar.defaultProps = {
  height: 5
};
var _default = ProgressBar;
exports.default = _default;